<script lang="ts" setup>
import { onMounted, onUnmounted, ref } from "vue";
import axios from "axios";
import { useRouter } from "vue-router";
import NodesTable from "../components/tables/NodesTable.vue";

const tableData = ref([]);
const loading = ref(true);
const loadedOnce = ref(false);

let poll = true;
let timerRef = 0;
async function loadData() {
  const res = await axios.get(`${window.origin}/api/environments`);
  tableData.value = res.data;
}

async function doPolling() {
  if (!poll) return;

  loading.value = true;
  try {
    await loadData();
  } catch (error) {
    console.log(error);
  }
  loading.value = false;
  loadedOnce.value = true;

  timerRef = setTimeout(doPolling, 5000);
}

onMounted(() => {
  doPolling();
});

onUnmounted(() => {
  poll = false;
  clearTimeout(timerRef);
});

const router = useRouter();
</script>

<template>
  <div class="items-left justify-center">
    <NodesTable :tableData="tableData" :loading="!loadedOnce && loading" />
  </div>
  <Spinner v-show="loadedOnce && loading" :size="30" />
</template>
